package com.muyu.enterprise.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.github.yulichang.wrapper.MPJLambdaWrapper;
import com.muyu.enterprise.mapper.WarnStrategyMapper;
import com.muyu.enterprise.service.WarnStrategyService;
import com.muyu.common.core.utils.StringUtils;
import com.muyu.domain.VehicleType;
import com.muyu.domain.WarnStrategy;
import com.muyu.domain.req.WarnVehicleReq;
import com.muyu.domain.resp.WarnVehicleResp;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class WarnStrategyServiceImpl extends ServiceImpl<WarnStrategyMapper, WarnStrategy>
        implements WarnStrategyService {

    @Autowired
    private WarnStrategyMapper warnStrategyMapper;

    @Override
    public List<WarnVehicleResp> ruleStrategyList(WarnVehicleReq warnVehicleReq) {
        MPJLambdaWrapper<WarnStrategy> wrapper = new MPJLambdaWrapper<>();
        wrapper.selectAll(WarnStrategy.class)
                .selectAs(VehicleType::getVehicleTypeName,WarnVehicleResp::getVehicleTypeName)
                .leftJoin(VehicleType.class,  VehicleType::getVehicleTypeId,WarnStrategy::getVehicleTypeId)
                .like(
                        StringUtils.isNotEmpty(warnVehicleReq.getStrategyName()),
                        WarnStrategy::getStrategyName,warnVehicleReq.getStrategyName()
                );
        List<WarnVehicleResp> list = warnStrategyMapper.selectJoinList(WarnVehicleResp.class, wrapper);
        return list;
    }
}
