package com.muyu.processing.controller;

import com.alibaba.fastjson.JSONObject;
import com.muyu.common.core.constant.KafkaConstants;
import com.muyu.common.kafka.config.KafkaProducerConfig;
import lombok.extern.log4j.Log4j2;
import org.apache.kafka.clients.producer.KafkaProducer;
import org.apache.kafka.clients.producer.ProducerRecord;
import org.apache.kafka.common.protocol.types.Field;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * @Author：杨鹏
 * @Package：com.muyu.processing.controller
 * @Project：car-cloud-server
 * @name：TestKafka
 * @Date：2024/9/28 21:17
 */
@Log4j2
@RestController
@RequestMapping("/kafka")
public class TestKafka {


    @Resource
    private KafkaProducer<String, String> kafkaProducer;

    @GetMapping("/send")
    public void sendMsg(){
        ProducerRecord<String, String> producerRecord = new ProducerRecord<>("zeshi", "你好啊");
        kafkaProducer.send(producerRecord);
    }

}
